// code by jph

class aniFloatable : public aniMated {
public:
  aniFloatable(char* msh_,char* ins_,double buo,char* ext_,char* nrm_,double res);
  void draw(void);
  char* toString(void) { return "aniFloatable"; };
  tensor<double> ins;
  tensor<double> ins_dsp;
  tensor<double> ext;
  tensor<double> ext_dsp;
  tensor<double> nrm;
  tensor<double> cum;
  double buoyancy;
  double resist;
};



void aniFloatable::draw(void) {
  msh->draw();
  if (0) {
    glPointSize(2);
    glBegin(GL_POINTS);
      glColor3d( 1.0, 0.0, 0.0);
      for (int c0=0;c0<ext.numel;c0+=4)
        glVertex3dv(ext^c0);
    glEnd();
    glLineWidth(1);
    glBegin(GL_LINES);
      glColor3d( 0.0, 1.0, 0.0);
      for (int c0=0;c0<ext.size[1];++c0) {
        glVertex3dv(ext^c0*4);
        glVertex3dv((ext[c0]+nrm[c0]*cum.data[c0]).data);
      }
    glEnd();    
  }
  ext_dsp=0;
  
  if (0) {
    glLineWidth(1);
    glBegin(GL_LINES);
      glColor3d( 0.0, 1.0, 0.0);
      for (int c0=0;c0<ins.size[1];++c0) {
        glVertex3dv(ins^c0*4);
        glVertex3dv((ins[c0]+ins_dsp[c0]*2).data);
      }
    glEnd();
  }
  ins_dsp=0;
}

