// code by jph

class aniAvatar : public aniMated {
public:
  aniAvatar(void);
  void scene(void);
  char* toString(void) { return "aniAvatar"; };
};

aniAvatar::aniAvatar(void) {
  status|=ANI_MOTION;
}

void aniAvatar::scene(void) {
  if (this==aniMated::humanized) {
    acc+=tensor<double>::vector(4).as((keyboard(KEY_AR)-keyboard(KEY_AL))*15.0*fva(0),
                                      (keyboard(KEY_PU)-keyboard(KEY_PD))*15.0*fva(1),
                                      (keyboard(KEY_AD)-keyboard(KEY_AU))*15.0*fva(2),0.0);
    //double fac=1/aniMated::dt;
    tor   +=glD(mouse_drag)[2]*(2/aniMated::dt);
    tor(2)+=(keyboard(KEY_IN)-keyboard(KEY_P1))*3.0;
    if (keyboard(KEY_EN)) {
      vel=0;
      ome=0;
    }
    if (keyboard('a')) {
      opengl_bulletin.add(tensor<char>::string( "avatar\n (l)oad position\n (s)ave position" ));
      if (keyboard_down('s'))
        pos.store("get/tensor/avatar.pos");
      if (keyboard_down('l')) {
        tensor<double> lod("get/tensor/avatar.pos");
        if (lod.data)
          pos=lod;
      }
    }
  }
}
